{block title}
    Task
{/block}
{block header}
    Úvod
{/block}

{block content}
<section>
    <div class="page-wrapper">
        <div class="container mt-4">
            <div class="content">
                <h1>Zadání</h1>

                <h2>A máme tu problém</h2>

                <p>Údaje o našich produktech máme uloženy v databázi ElasticSearch i MySQL. Údaje jsou stejné
                    v obou a dotazujeme se hlavně na ElasticSearch. Čas od času však potřebujeme data získat
                    přímo z MySQL, zatímco provádíme několik efektních experimentů v ElasticSearch. Rádi bychom získali
                    přístup k datům o konkrétním produktu z našeho frontendu, abychom je mohli zobrazit zákazníkovi.</p>

                <p>Protože máme poměrně velký provoz, potřebujeme také implementovat nějaký druh mezipaměti. Jednoduchá
                    filesystem cache je prozatím dostačující, ale musíme ji umět přepnout na něco
                    pokročilejšího v budoucnu jen úpravou konfiguračního souboru.</p>

                <p>Obchod vždy potřebuje vědět, jaké jsou nejúspěšnější produkty. Proto musíme také sledovat
                    počet požadavků na každý produkt. Prozatím jsme vpohodě s ukládáním informací do
                    textového souboru. Mějte na paměti, že úložiště budeme muset v budoucnu také změnit a vyměnit
                    za něco robustnějšího.</p>

                <h2>Vaše mise, drahý kandidáte, pokud se ji rozhodnete přijmout</h2>

                <p>Měli byste vytvořit nový controller s metodou akceptující id produktu jako parametr. Metoda by měla
                    vrátit json reprezentaci produktových dat.</p>

                <p>Základní pracovní postup pro daný úkol:</p>

                <ul>
                    <li>Přijde požadavek s ID produktu.</li>
                    <li>Pokud je produkt v mezipaměti, načtěte z mezipaměti.</li>
                    <li>Pokud produkt není v mezipaměti, načtěte jej z ElasticSearch/MySQL a přidejte do mezipaměti.
                    </li>
                    <li>Zvyšte počet požadavků na daný produkt.</li>
                    <li>Vraťte produktová data ve formátu JSON.</li>
                </ul>

                <p>Controller může vypadat následovně:</p>

                <pre>
                    <code>
    class ProductController
    {

        /**
         * @param string $id
         * @return string
         */
        public function detail($id)
        {
            // do stuff and return json
        }

    }
                    </code>
                </pre>

                <h2>Věci, které vám mohou pomoci</h2>

                <p>Máme ovladače pro ElasticSearch i MySQL, takže je nemusíte psát. Můžete předpokládat, že fungují a
                    voláním jejich metod získáte řadu dat pro daný produkt a každá z nich implementuje své rozhraní:</p>

                <pre>
                    <code>

    interface IElasticSearchDriver
    {
        /**
        * @param string $id
        * @return array
        */
        public function findById($id);
    }

    interface IMySQLDriver
    {
        /**
        * @param string $id
        * @return array
        */
        public function findProduct($id);
    }
                    </code>
                </pre>

                <p>Můžete také bezpečně předpokládat, že:</p>

                <ul>
                    <li>Vnější framework dělá přesně to, co potřebujete. Pokud potřebujete předat nějaké parametry
                        konstruktoru controlleru, vždy předá ty správné.
                    </li>
                    <li>Ať je předáno jakékoli ID produktu, řidiči vždy najdou produkt. Výjimky typu „Nenalezeno“
                        nemusíte řešit.
                    </li>
                    <li>Cache je nekonečná. Nemusíte se obávat znehodnocení cache. Jakmile jsou data uložena do
                        mezipaměti, nemusíme je nikdy odstraňovat.
                    </li>
                    <li>Informace o počtu požadavků na daný produkt je pouze jednoduchá dvojice productId =>
                        numberOfRequests, žádné další informace nejsou potřeba.
                    </li>
                </ul>

            </div>
        </div>
    </div>
</section>

<style>
</style>
